#include <QApplication>
#include <QListWidget>
#include <QListWidgetItem>
#include <QDebug>
#include <QStringList>

static bool optMargins = true;

class MyListWidget : public QListWidget {
public:
    MyListWidget(QWidget *parent = nullptr) : QListWidget(parent)
    {
        if (optMargins)
            setViewportMargins(20, 50, 0, 0);
    }
};

int main(int argc, char** argv)
{
    QApplication a(argc, argv);
    QStringList args = a.arguments();
    args.pop_front();

    qDebug() << QT_VERSION_STR << args;

    optMargins = !args.contains("-m");
    const QListWidget::ViewMode vm = args.contains("-i")
            ? QListWidget::ListMode
            : QListWidget::IconMode;

    const QAbstractItemView::ScrollMode sm = args.contains("-p")
            ? QAbstractItemView::ScrollPerPixel
            : QAbstractItemView::ScrollPerItem;

    int nItems = 20;

    int idx = args.indexOf("-n");
    if (idx >= 0)
        nItems = args.at(idx + 1).toInt();

    MyListWidget w;
    w.setWindowTitle(QT_VERSION_STR);

    w.setViewMode(vm);
    w.setVerticalScrollMode(sm);
    qDebug() << QT_VERSION_STR << vm << sm;

    for (int i = 0; i < nItems; ++i)
        w.addItem(new QListWidgetItem("TEST " + QString::number(i)));

    w.show();

    return a.exec();
}
